from __future__ import division
import es
import playerlib
import shelve
import time

info = es.AddonInfo()
info['name']        = "SimpleRanks"
info['version']     = "2.1"
info['author']      = "3R10N"
info['url']         = "http://addons.eventscripts.com/addons/view/simpleranks"
info['description'] = "A simple ranking system that counts your kills and deaths"
info['basename']    = "simpleranks" 

es.ServerVar('simpleranks', info['version'], 'SimpleRanks made by 3R10N').makepublic() 

simp_prune_hours = 720

sr_stats = shelve.open(es.getAddonPath('simpleranks') + '/data.db', writeback=True) 
simp_organization = []

def load(): 
  simp_sort_process() 
  es.regsaycmd('!stats','simpleranks/simp_stats_send')
  es.regsaycmd('!kdr','simpleranks/simp_kdr_send')
  es.regsaycmd('!rank','simpleranks/simp_rank_send')
  for userid in es.getUseridList(): 
      player_spawn({'userid':str(userid)}) 

def es_map_start(event_var): 
   global sr_stats 

   now = time.time() 
   simp_prune_secs = simp_prune_hours * 3600 
   for simp_uid in filter(lambda x: now - sr_stats[x]['connection_time'] > simp_prune_secs, sr_stats): 
      del sr_stats[simp_uid] 
   sr_stats.sync() 
   simp_sort_process() 
   
def player_spawn(event_var): 
   global sr_stats 

   userid = event_var['userid'] 
   simp_uid = playerlib.uniqueid(userid, True) 
   if sr_stats.has_key(simp_uid): 
      sr_stats[simp_uid]['connection_time'] = time.time() 
   else: 
      sr_stats[simp_uid] = {'kills':0, 'deaths':0, 'connection_time':time.time()} 
      simp_sort_process() 
	  
def player_death(event_var): 
   global sr_stats 

   if event_var['es_userteam'] != event_var['es_attackerteam']: 
      simp_uid_temp = event_var['userid'] 
      simp_uid = playerlib.uniqueid(simp_uid_temp, True) 
      sr_stats[simp_uid]['deaths'] += 1 

      simp_aid_temp = event_var['attacker'] 
      simp_aid = playerlib.uniqueid(simp_aid_temp, True) 
      sr_stats[simp_aid]['kills'] += 1
	  
   simp_sort_process() 

def simp_stats_send():
   simp_cuid_temp = es.getcmduserid()
   simp_cuid = playerlib.uniqueid(simp_cuid_temp, True)
   es.tell(simp_cuid_temp, '#multi', '#defaultYou have#lightgreen %(kills)s#green kills#default and#lightgreen %(deaths)s#green deaths#default.' % sr_stats[simp_cuid])

def simp_kdr_send():
   simp_cuid_temp = es.getcmduserid()
   simp_cuid = playerlib.uniqueid(simp_cuid_temp, True)
   simp_kills = sr_stats[simp_cuid]['kills']
   simp_deaths = sr_stats[simp_cuid]['deaths']
   if simp_deaths > 0:
      simp_kdr = simp_kills / simp_deaths
      es.tell(simp_cuid_temp, '#multi', '#defaultYour#green kill-death ratio is#default %s' % round(simp_kdr, 2))
   else:
      es.tell(simp_cuid_temp, '#multi', '#defaultCan\'t divide by 0,#green sorry!')

def simp_rank_send():
   simp_cuid_temp = es.getcmduserid()
   simp_cuid = playerlib.uniqueid(simp_cuid_temp, True)
   simp_current_rank_info = sr_stats[simp_cuid]
   es.tell(simp_cuid_temp, '#multi', '#defaultYou are ranked #lightgreen%s of %s#default with#lightgreen %s#green kills#default and#lightgreen %s#green deaths' % (simp_organization.index(simp_cuid) + 1, len(simp_organization), simp_current_rank_info['kills'], simp_current_rank_info['deaths'])) 
	  
def unload(): 
   sr_stats.close()
   
def simp_sort_process(): 
   def simp_sort(simp_puid1, simp_puid2): 
      simp_puid_b = sr_stats[simp_puid1] 
      simp_puid_a = sr_stats[simp_puid2] 

      if simp_puid_b['kills'] < simp_puid_a['kills'] or (simp_puid_b['kills'] == simp_puid_a['kills'] and simp_puid_b['deaths'] > simp_puid_a['deaths']) or (simp_puid_b['kills'] == simp_puid_a['kills'] and simp_puid_b['deaths'] == simp_puid_a['deaths'] and simp_puid_b['connection_time'] < simp_puid_a['connection_time']): 
         return 1 
      if simp_puid_b['kills'] == simp_puid_a['kills'] and simp_puid_b['deaths'] == simp_puid_a['deaths'] and simp_puid_b['connection_time'] == simp_puid_a['connection_time']: 
         return 0 
      return -1 

   global simp_organization 

   simp_organization = sorted(sr_stats, simp_sort)   